import tornado.httpserver
import tornado.ioloop
import tornado.web
import pymongo
from pymongo import MongoClient
import json
import ast
import os
import re
from bson import json_util
import datetime
import math
import hashlib
import sys

def PreLoad():
   global config_data
   if os.path.exists("/etc/pimon_config.json"):
      with open('/etc/pimon_config.json') as config:
         config_data = json.load(config)
      if config_data['admin']['create_admin'] == "yes":
         result = getonedata("users", "username" , "admin")
         if result == None:
            data = {
               "username":"admin",
               "password": hashlib.sha512(config_data['admin']['password'].encode('utf-8') + config_data['settings']['secure_cookie'].encode('utf-8')).hexdigest(),
               "timestamp": datetime.datetime.now()
            }
            postdata("users", data)
         if config_data['admin']['force_admin'] == "yes":
            fquery = { 'username' : 'admin' }
            uquery = {"$set": {"password": hashlib.sha512(config_data['admin']['password'].encode('utf-8') + config_data['settings']['secure_cookie'].encode('utf-8')).hexdigest()}}
            findandupdate("users", fquery, uquery)
         else:
            print("""ERROR: Admin user already exists, If you want to overwrite the current admin user you need to add the "force_admin": "yes" to the admin section in your config.json""")
   else:
      sys.exit("No config file, Copy the default from /usr/share/pimon-server/web/config.json.default to /etc")

with open('/usr/share/pimon-server/web/rpi.json') as f:
   rpi_data = json.load(f)

def findandupdate(database, fquery, uquery):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   count = posts.find_one_and_update(fquery, uquery)
   client.close()

def GetCount(database):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   count = posts.count()
   client.close()
   return count

def postdata(database, post_data):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   result = posts.insert_one(post_data)
   client.close()

def getdata(database):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   data = posts.find(sort=[( '_id', pymongo.DESCENDING )])
   client.close()
   return data

def getonedata(database, key, value):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   data = posts.find_one({key : value}, sort=[( 'timestamp', pymongo.DESCENDING )])
   client.close()
   return data

def DeleteQuery(database, query):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   data = posts.remove(query)
   client.close()
   print(data)

def SearchData(database, key, value):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   data = posts.find({key : value}, sort=[( '_id', pymongo.DESCENDING )])
   client.close()
   return data

def SearchData2(database, key, value, end, start, interval):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   if interval == "Minute":
      data = posts.aggregate([
          {"$match": {key : value}},
          {"$match": {"timestamp": {
                           "$gt": start,
                           "$lt": end
                           }
                  }
          },
          {"$group": {
              "_id" : { "$concat": [
                  {"$substr": [{"$year": "$timestamp"}, 0, 4 ]},
                  "-",
                  {"$substr": [{"$month": "$timestamp"}, 0, 2 ]},
                  "-",
                  {"$substr": [{"$dayOfMonth": "$timestamp"}, 0, 2 ]},
                  " ",
                  {"$substr": [{"$hour": "$timestamp"}, 0, 2 ]},
                  " ",
                  {"$substr": [{"$minute": "$timestamp"}, 0, 2 ]},
              ]},
              "cpu_load": { "$avg": "$cpu_load_1" },
              "ram_pct": {"$avg": "$ram_pct" },
              "pct_disk": {"$avg": "$pct_disk" },
              "cpu_temp": {"$avg": "$cpu_temp" },
              "timestamp": {"$first": "$timestamp" }
           }},
           {"$sort": { "timestamp": 1 }}
         ])
      client.close()
   if interval == "Hour":
      data = posts.aggregate([
          {"$match": {key : value}},
          {"$match": {"timestamp": {
                           "$gt": start,
                           "$lt": end
                           }
                  }
          },
          {"$group": {
              "_id" : { "$concat": [
                  {"$substr": [{"$year": "$timestamp"}, 0, 4 ]},
                  "-",
                  {"$substr": [{"$month": "$timestamp"}, 0, 2 ]},
                  "-",
                  {"$substr": [{"$dayOfMonth": "$timestamp"}, 0, 2 ]},
                  " ",
                  {"$substr": [{"$hour": "$timestamp"}, 0, 2 ]},
              ]},
              "cpu_load": { "$avg": "$cpu_load_1" },
              "ram_pct": {"$avg": "$ram_pct" },
              "pct_disk": {"$avg": "$pct_disk" },
              "cpu_temp": {"$avg": "$cpu_temp" },
              "timestamp": {"$first": "$timestamp" }
           }},
           {"$sort": { "timestamp": 1 }}
         ])
      client.close()
   if interval == "Day":
      data = posts.aggregate([
          {"$match": {key : value}},
          {"$match": {"timestamp": {
                           "$gt": start,
                           "$lt": end
                           }
                  }
          },
          {"$group": {
              "_id" : { "$concat": [
                  {"$substr": [{"$year": "$timestamp"}, 0, 4 ]},
                  "-",
                  {"$substr": [{"$month": "$timestamp"}, 0, 2 ]},
                  "-",
                  {"$substr": [{"$dayOfMonth": "$timestamp"}, 0, 2 ]},
              ]},
              "cpu_load": { "$avg": "$cpu_load_1" },
              "ram_pct": {"$avg": "$ram_pct" },
              "pct_disk": {"$avg": "$pct_disk" },
              "cpu_temp": {"$avg": "$cpu_temp" },
              "timestamp": {"$first": "$timestamp" }
           }},
           {"$sort": { "timestamp": 1 }}
         ])
      client.close()
   if interval == "Month":
      data = posts.aggregate([
          {"$match": {key : value}},
          {"$match": {"timestamp": {
                           "$gt": start,
                           "$lt": end
                           }
                  }
          },
          {"$group": {
              "_id" : { "$concat": [
                  {"$substr": [{"$year": "$timestamp"}, 0, 4 ]},
                  "-",
                  {"$substr": [{"$month": "$timestamp"}, 0, 2 ]},
              ]},
              "cpu_load": { "$avg": "$cpu_load_1" },
              "ram_pct": {"$avg": "$ram_pct" },
              "pct_disk": {"$avg": "$pct_disk" },
              "cpu_temp": {"$avg": "$cpu_temp" },
              "timestamp": {"$first": "$timestamp" }
           }},
           {"$sort": { "_id": 1 }}
         ])
      client.close()
   if interval == "Year":
      data = posts.aggregate([
          {"$match": {key : value}},
          {"$match": {"timestamp": {
                           "$gt": start,
                           "$lt": end
                           }
                  }
          },
          {"$group": {
              "_id" : { "$concat": [
                  {"$substr": [{"$year": "$timestamp"}, 0, 4 ]},
              ]},
              "cpu_load": { "$avg": "$cpu_load_1" },
              "ram_pct": {"$avg": "$ram_pct" },
              "pct_disk": {"$avg": "$pct_disk" },
              "cpu_temp": {"$avg": "$cpu_temp" },
              "timestamp": {"$first": "$timestamp" }
           }},
           {"$sort": { "timestamp": 1 }}
         ])
      client.close()
   return data

def update_one(database, query, newvalue):
   client = MongoClient()
   db = client[database]
   posts = db.posts
   posts.update_one(query, newvalue)
   client.close()

def failreq(self):
   self.clear()
   self.set_status(401)
   self.finish("Unauthorized")

PreLoad()

settings = {
    "static_path": os.path.join(os.path.dirname(__file__), "static"),
    "cookie_secret": config_data['settings']['secure_cookie'],
    "login_url": "/login",
}

class BaseHandler(tornado.web.RequestHandler):
   def get_current_user(self):
       return self.get_secure_cookie("user")

class IndexHandler(BaseHandler):
   @tornado.web.authenticated
   def get(self):
       data = SearchData('machines', 'authorized', 'yes')
       machinecount = GetCount("machines")
       count = math.ceil(machinecount / int(config_data['display']['home_display_count']))
       self.render('templates/index.html', data=data, config_data=config_data, count=count)

class RegHandler(tornado.web.RequestHandler):
   def post(self):
       data = self.get_body_argument("data")
       data = json.loads(data, object_hook=json_util.object_hook)
       id = data['id']
       machinedata = getonedata('machines', "id", id)
       if machinedata == None:
          if 'authorized' in data:
             failreq(self)
          else:
             data['authorized'] = 'no'
             data['client_version'] = '0.0.0'
             if data['revision'] in rpi_data:
                data['Model'] = rpi_data[data['revision']]['Model']
                data['Revision'] = rpi_data[data['revision']]['Revision']
                data['RAM'] = rpi_data[data['revision']]['RAM']
                data['Manufacturer'] = rpi_data[data['revision']]['Manufacturer']
             else:
                data['Model'] = "Unknown"
                data['Revision'] = "Unknown"
                data['RAM'] = "Unknown"
                data['Manufacturer'] = "Unknown"
             postdata('machines', data)
             self.write("Pending")
       if machinedata != None:
          if machinedata['authorized'] == "no":
             self.write("Pending")
          if machinedata['authorized'] == "yes":
             self.write("Authorized")
          if machinedata['authorized'] == "denied":
             self.write("Authorization has been denied for this machine.")


class APIHandler(tornado.web.RequestHandler):
   def post(self):
      data = self.get_body_argument("data")
      data = json.loads(data, object_hook=json_util.object_hook)
      id = self.get_body_argument('id')
      key = self.get_body_argument('api_key')
      machinedata = getonedata('machines', "id", id)
      query = { 'id' : id }
      newlast = { "$set": { "last": data['timestamp'] } }
      newversion = { "$set": { "client_version": data['client_version'] } }
      new_quick_stats = { "$set": {
                             "last": data['timestamp'],
                             "cpu_load_1": data['cpu_load_1'],
                             "cpu_count": data['cpu_count'],
                             "cpu_temp": data['cpu_temp'],
                             "used_ram": data['used_ram'],
                             "total_ram": data['total_ram'],
                             "ram_pct": data['ram_pct'],
                             "uptime": data['uptime'],
                             "pct_disk": data['pct_disk'],
                             "used_disk": data['used_disk'],
                             "total_disk": data['total_disk']
                         } }
      update_one("machines", query, newlast)
      update_one("machines", query, newversion)
      update_one("machines", query, new_quick_stats)
      if machinedata == None or key != machinedata['api_key'] or machinedata['authorized'] == "no" or machinedata['authorized'] == "denied":
         failreq(self)
      else:
         postdata('stats', data)
         self.write("Submission Successful")

class MachineHandler(BaseHandler):
   @tornado.web.authenticated
   def get(self):
      self.redirect("/")
   def post(self):
      id = self.get_body_argument("id")
      machine = getonedata('machines', "id", id)
      self.render('templates/machine.html', machine=machine, config_data=config_data)

class MachineManageHandler(BaseHandler):
   @tornado.web.authenticated
   def get(self):
      data = getdata('machines')
      self.render('templates/machinemanager.html', data=data, config_data=config_data)
   def post(self):
      id = self.get_body_argument("id")
      action = self.get_body_argument("action")
      if action == 'auth':
         query = { 'id' : id }
         newvalue = { "$set": { "authorized": "yes" } }
         update_one('machines', query, newvalue)
      if action == 'deauth':
         query = { 'id' : id }
         newvalue = { "$set": { "authorized": "denied" } }
         update_one('machines', query, newvalue)
      if action == 'purge':
         query = { 'id' : id }
         DeleteQuery("stats", query)
      if action == 'delete':
         query = { 'id' : id }
         DeleteQuery("stats", query)
         DeleteQuery("machines", query)
      if action == 'clear':
         query = { 'id' : id }
         DeleteQuery("machines", query)
      data = getdata('machines')
      self.render('templates/machinemanager.html', data=data, config_data=config_data)

class GraphHandler(BaseHandler):
   @tornado.web.authenticated
   def get(self):
      data = getdata('stats')
      self.render("templates/loader.html")
   def post(self):
      id = self.get_body_argument("id")
      graph = self.get_body_argument("graph")
      interval = self.get_body_argument("interval")
      start = self.get_body_argument("start")
      start = datetime.datetime.strptime(start, "%m-%d-%YT%H:%M %z")
      end = self.get_body_argument("end")
      end = datetime.datetime.strptime(end, "%m-%d-%YT%H:%M %z")
      data = SearchData2('stats', 'id', id, end, start, interval)
      data = json_util.dumps(data)
      data = json.loads(data)
      self.render('templates/graph.html', data=data, graph=graph)

class UserHandler(BaseHandler):
   @tornado.web.authenticated
   def get(self):
      data = getdata('users')
      self.render("templates/users.html", data=data, config_data=config_data)

   def post(self):
      action = self.get_body_argument("action")
      if action == "create":
        username = self.get_argument("username")
        password = self.get_argument("password")
        usercheck = getonedata("users", "username" , username)
        if usercheck == None:
           data = {
              "username": username,
              "password": hashlib.sha512(password.encode('utf-8') + config_data['settings']['secure_cookie'].encode('utf-8')).hexdigest(),
              "timestamp": datetime.datetime.now()
           }
           postdata("users", data)
           result = "user Created"
        else:
           result = "Error User Already Exists"
      if action == "delete":
         username = self.get_argument("username")
         query = { 'username' : username }
         DeleteQuery("users", query)
         result = "User Deleted"
      data = getdata('users')
      if action == "editpass":
         username = self.get_argument("username")
         password = self.get_argument("password")
         query = { 'username' : username }
         newvalue = { "$set": { "password": hashlib.sha512(password.encode('utf-8') + config_data['settings']['secure_cookie'].encode('utf-8')).hexdigest() } }
         update_one("users", query, newvalue)
         result = "User Updated"
      if action == "edit":
         username = self.get_argument("username")
         self.render("templates/user-edit.html", data=data, config_data=config_data, username=username)
      else:
         self.render("templates/users.html", data=data, config_data=config_data, result=result)

class LoginHandler(BaseHandler):
    def get(self):
        self.render("templates/login.html")

    def post(self):
        name = self.get_argument("username")
        password = self.get_argument("password")
        result = getonedata("users", "username" , name)
        if result == None:
           self.redirect("/login")
        elif result != None:
           if hashlib.sha512(password.encode('utf-8') + config_data['settings']['secure_cookie'].encode('utf-8')).hexdigest() == result['password']:
              self.set_secure_cookie("user", self.get_argument("username"))
              self.redirect("/")
        else:
           self.redirect("/login")

application = tornado.web.Application([
    (r'/', IndexHandler),
    (r'/api/register', RegHandler),
    (r'/api', APIHandler),
    (r'/machine', MachineHandler),
    (r'/machine/manager', MachineManageHandler),
    (r'/graph', GraphHandler),
    (r'/settings/users', UserHandler),
    (r'/login', LoginHandler),
    (r"/(.*)", tornado.web.StaticFileHandler,
    dict(path=settings['static_path'])),
    ], **settings)


if __name__ == '__main__':
    http_server = tornado.httpserver.HTTPServer(application, ssl_options={
        "certfile": "/usr/share/pimon-server/web/main.crt",
        "keyfile": "/usr/share/pimon-server/web/main.key",
    })
    http_server.listen(443)
    http_server.start(32)
    tornado.ioloop.IOLoop.instance().start()
